# Interface methods for submodule: ImageIOBase
from typing import Union, Any
# additional imports
from .support.template_class import itkTemplate as _itkTemplate
from ._proxies import LightProcessObjectProxy as _LightProcessObjectProxy


# Interface methods for class: ImageIOBase
class ImageIOBaseProxy(_LightProcessObjectProxy):
	def GetNameOfClass(self):
		""""""
		...

	@overload
	def SetFileName(self, _arg) -> None:
		""""""
		...

	@overload
	def SetFileName(self, _arg: str) -> None:
		""""""
		...

	def GetFileName(self):
		""""""
		...

	def SetNumberOfDimensions(self, arg0: int) -> None:
		""""""
		...

	def GetNumberOfDimensions(self) -> int:
		""""""
		...

	def SetDimensions(self, i: int, dim: int) -> None:
		""""""
		...

	def GetDimensions(self, i: int) -> int:
		""""""
		...

	def SetOrigin(self, i: int, origin: float) -> None:
		""""""
		...

	def GetOrigin(self, i: int) -> float:
		""""""
		...

	def SetSpacing(self, i: int, spacing: float) -> None:
		""""""
		...

	def GetSpacing(self, i: int) -> float:
		""""""
		...

	@overload
	def SetDirection(self, i: int, direction: Sequence[float]) -> None:
		""""""
		...

	@overload
	def SetDirection(self, i: int, direction: vnl_vector) -> None:
		""""""
		...

	def GetDirection(self, i: int) -> Sequence[float]:
		""""""
		...

	def GetDefaultDirection(self, k: int) -> Sequence[float]:
		""""""
		...

	def SetIORegion(self, _arg) -> None:
		""""""
		...

	def GetIORegion(self):
		""""""
		...

	def SetPixelType(self, _arg) -> None:
		""""""
		...

	def GetPixelType(self):
		""""""
		...

	def SetComponentType(self, _arg) -> None:
		""""""
		...

	def GetComponentType(self):
		""""""
		...

	def GetComponentTypeInfo(self):
		""""""
		...

	def SetNumberOfComponents(self, _arg: int) -> None:
		""""""
		...

	def GetNumberOfComponents(self) -> int:
		""""""
		...

	def SetUseCompression(self, _arg: bool) -> None:
		""""""
		...

	def GetUseCompression(self) -> bool:
		""""""
		...

	def UseCompressionOn(self) -> None:
		""""""
		...

	def UseCompressionOff(self) -> None:
		""""""
		...

	def SetCompressionLevel(self, _arg: int) -> None:
		""""""
		...

	def GetCompressionLevel(self) -> int:
		""""""
		...

	def SetCompressor(self, _c: str) -> None:
		""""""
		...

	def GetCompressor(self) -> str:
		""""""
		...

	def SetUseStreamedReading(self, _arg: bool) -> None:
		""""""
		...

	def GetUseStreamedReading(self) -> bool:
		""""""
		...

	def UseStreamedReadingOn(self) -> None:
		""""""
		...

	def UseStreamedReadingOff(self) -> None:
		""""""
		...

	def SetUseStreamedWriting(self, _arg: bool) -> None:
		""""""
		...

	def GetUseStreamedWriting(self) -> bool:
		""""""
		...

	def UseStreamedWritingOn(self) -> None:
		""""""
		...

	def UseStreamedWritingOff(self) -> None:
		""""""
		...

	def SetExpandRGBPalette(self, _arg: bool) -> None:
		""""""
		...

	def GetExpandRGBPalette(self) -> bool:
		""""""
		...

	def ExpandRGBPaletteOn(self) -> None:
		""""""
		...

	def ExpandRGBPaletteOff(self) -> None:
		""""""
		...

	def SetWritePalette(self, _arg: bool) -> None:
		""""""
		...

	def GetWritePalette(self) -> bool:
		""""""
		...

	def WritePaletteOn(self) -> None:
		""""""
		...

	def WritePaletteOff(self) -> None:
		""""""
		...

	def GetIsReadAsScalarPlusPalette(self) -> bool:
		""""""
		...

	@staticmethod
	def GetComponentTypeAsString(arg0) -> str:
		""""""
		...

	@staticmethod
	def GetComponentTypeFromString(typeString: str):
		""""""
		...

	@staticmethod
	def GetPixelTypeAsString(arg0) -> str:
		""""""
		...

	@staticmethod
	def GetPixelTypeFromString(pixelString: str):
		""""""
		...

	def SetFileType(self, _arg) -> None:
		""""""
		...

	def GetFileType(self):
		""""""
		...

	def SetFileTypeToASCII(self) -> None:
		""""""
		...

	def SetFileTypeToBinary(self) -> None:
		""""""
		...

	def SetByteOrder(self, _arg) -> None:
		""""""
		...

	def GetByteOrder(self):
		""""""
		...

	def SetByteOrderToBigEndian(self) -> None:
		""""""
		...

	def SetByteOrderToLittleEndian(self) -> None:
		""""""
		...

	def GetFileTypeAsString(self, arg0) -> str:
		""""""
		...

	def GetByteOrderAsString(self, arg0) -> str:
		""""""
		...

	def GetPixelStride(self) -> int:
		""""""
		...

	def GetImageSizeInPixels(self) -> int:
		""""""
		...

	def GetImageSizeInBytes(self) -> int:
		""""""
		...

	def GetImageSizeInComponents(self) -> int:
		""""""
		...

	def GetComponentSize(self) -> int:
		""""""
		...

	def CanReadFile(self, arg0) -> bool:
		""""""
		...

	def CanStreamRead(self) -> bool:
		""""""
		...

	def ReadImageInformation(self) -> None:
		""""""
		...

	def Read(self, buffer) -> None:
		""""""
		...

	def CanWriteFile(self, arg0) -> bool:
		""""""
		...

	def CanStreamWrite(self) -> bool:
		""""""
		...

	def WriteImageInformation(self) -> None:
		""""""
		...

	def Write(self, buffer) -> None:
		""""""
		...

	def SupportsDimension(self, dim: int) -> bool:
		""""""
		...

	def GenerateStreamableReadRegionFromRequestedRegion(self, requested):
		""""""
		...

	def GetActualNumberOfSplitsForWriting(self, numberOfRequestedSplits: int, pasteRegion, largestPossibleRegion) -> int:
		""""""
		...

	def GetSplitRegionForWriting(self, ithPiece: int, numberOfActualSplits: int, pasteRegion, largestPossibleRegion):
		""""""
		...

	def GetSupportedReadExtensions(self):
		""""""
		...

	def GetSupportedWriteExtensions(self):
		""""""
		...

